Subject: [tcpm] Review of draft-ietf-tcpm-rack-08

From: Yi Huang <[email-masked]>
Date: Tue, 7 Apr 2020 21:33:50 +0000

I reviewed the latest version of RACK and I have a few questions about the RACK timer.

  1.  In Section 7.2, Step 5: Detect losses, the draft states how/when the RACK timer is armed. However, it's not very clear that how/when it is canceled. I suppose when a cumulative ACK arrives and RACK_detect_loss() returns with timeout = 0, it should be canceled? Are the RACK timer and the RTO timer mutually exclusive?

  1.  When the RACK timer fires and calls RACK_detect_loss(), due to clock granularity, the packets, for which the timer was scheduled for, might have not expired yet. Thus, the RACK timer might be scheduled several times for the same set of packets  even when there is no new (S)ACK coming back. I think it would be helpful to implementers if this is addressed/discussed in the spec.

Thanks,

Yi